setfreq m32;
Symbol red = C.0
Symbol green = B.2
Symbol blue = B.4
Symbol light = C.1
Symbol lightstate = b12
Symbol rduty = b1
Symbol orraw = b4
Symbol rraw = b7
Symbol gduty = b2
Symbol ograw = b5
Symbol graw = b8
Symbol bduty = b3
Symbol obraw = b6
Symbol braw = b9
low red
low green
low blue
low light
let rraw = 0
let graw = 0
let braw = 0
pwmout red,25,0
pwmout green,25,0
pwmout blue,25,0
goto read_rf

light_on:
high light
goto read_rf

light_off:
low light
goto read_rf

rpwm_adjust:
let orraw = rraw
pwmduty red,rduty
goto read_rf

gpwm_adjust:
let ograw = graw
pwmduty green,gduty
goto read_rf

bpwm_adjust:
let obraw = braw
pwmduty blue,bduty
goto read_rf

read_rf:
rfin B.3,rraw,graw,braw,lightstate,b13,b14,b10,b11
if rraw != orraw then goto rlookup
if graw != ograw then goto glookup
if braw != obraw then goto blookup
if lightstate = 1 then goto light_on
if lightstate = 0 then goto light_off
debug
goto read_rf

rlookup:
if rraw >= 37 then gosub r3
if rraw >= 24 then gosub r2
if rraw >= 10 then gosub r1
if rraw = 0 then let rduty = 0 goto rpwm_adjust
endif
if rraw = 1 then let rduty = 0 goto rpwm_adjust
endif
if rraw = 2 then let rduty = 1 goto rpwm_adjust
endif
if rraw = 3 then let rduty = 1 goto rpwm_adjust
endif
if rraw = 4 then let rduty = 1 goto rpwm_adjust
endif
if rraw = 5 then let rduty = 2 goto rpwm_adjust
endif
if rraw = 6 then let rduty = 3 goto rpwm_adjust
endif
if rraw = 7 then let rduty = 3 goto rpwm_adjust
endif
if rraw = 8 then let rduty = 4 goto rpwm_adjust
endif
if rraw = 9 then let rduty = 5 goto rpwm_adjust
r1:
endif
if rraw = 10 then let rduty = 6 goto rpwm_adjust
endif
if rraw = 11 then let rduty = 7 goto rpwm_adjust
endif
if rraw = 12 then let rduty = 8 goto rpwm_adjust
endif
if rraw = 13 then let rduty = 9 goto rpwm_adjust
endif
if rraw = 14 then let rduty = 10 goto rpwm_adjust
endif
if rraw = 15 then let rduty = 11 goto rpwm_adjust
endif
if rraw = 16 then let rduty = 13 goto rpwm_adjust
endif
if rraw = 17 then let rduty = 14 goto rpwm_adjust
endif
if rraw = 18 then let rduty = 15 goto rpwm_adjust
endif
if rraw = 19 then let rduty = 17 goto rpwm_adjust
endif
if rraw = 20 then let rduty = 18 goto rpwm_adjust
endif
if rraw = 21 then let rduty = 20 goto rpwm_adjust
endif
if rraw = 22 then let rduty = 22 goto rpwm_adjust
endif
if rraw = 23 then let rduty = 24 goto rpwm_adjust
r2:
endif
if rraw = 24 then let rduty = 25 goto rpwm_adjust
endif
if rraw = 25 then let rduty = 28 goto rpwm_adjust
endif
if rraw = 26 then let rduty = 30 goto rpwm_adjust
endif
if rraw = 27 then let rduty = 32 goto rpwm_adjust
endif
if rraw = 28 then let rduty = 34 goto rpwm_adjust
endif
if rraw = 29 then let rduty = 37 goto rpwm_adjust
endif
if rraw = 30 then let rduty = 40 goto rpwm_adjust
endif
if rraw = 31 then let rduty = 42 goto rpwm_adjust
endif
if rraw = 32 then let rduty = 46 goto rpwm_adjust
endif
if rraw = 33 then let rduty = 49 goto rpwm_adjust
endif
if rraw = 34 then let rduty = 52 goto rpwm_adjust
endif
if rraw = 35 then let rduty = 56 goto rpwm_adjust
endif
if rraw = 36 then let rduty = 60 goto rpwm_adjust
r3:
endif
if rraw = 37 then let rduty = 65 goto rpwm_adjust
endif
if rraw = 38 then let rduty = 70 goto rpwm_adjust
endif
if rraw = 39 then let rduty = 75 goto rpwm_adjust
endif
if rraw = 40 then let rduty = 81 goto rpwm_adjust
endif
if rraw = 41 then let rduty = 88 goto rpwm_adjust
endif
if rraw = 42 then let rduty = 96 goto rpwm_adjust
endif
if rraw = 43 then let rduty = 105 goto rpwm_adjust
endif
if rraw = 44 then let rduty = 115 goto rpwm_adjust
endif
if rraw = 45 then let rduty = 129 goto rpwm_adjust
endif
if rraw = 46 then let rduty = 146 goto rpwm_adjust
endif
if rraw = 47 then let rduty = 170 goto rpwm_adjust
endif
if rraw = 48 then let rduty = 212 goto rpwm_adjust
endif
if rraw = 49 then let rduty = 255 goto rpwm_adjust
endif
goto rpwm_adjust

glookup:
if graw >= 37 then gosub g3
if graw >= 24 then gosub g2
if graw >= 10 then gosub g1
if graw = 0 then let gduty = 0 goto gpwm_adjust
endif
if graw = 1 then let gduty = 0 goto gpwm_adjust
endif
if graw = 2 then let gduty = 1 goto gpwm_adjust
endif
if graw = 3 then let gduty = 1 goto gpwm_adjust
endif
if graw = 4 then let gduty = 1 goto gpwm_adjust
endif
if graw = 5 then let gduty = 2 goto gpwm_adjust
endif
if graw = 6 then let gduty = 3 goto gpwm_adjust
endif
if graw = 7 then let gduty = 3 goto gpwm_adjust
endif
if graw = 8 then let gduty = 4 goto gpwm_adjust
endif
if graw = 9 then let gduty = 5 goto gpwm_adjust
g1:
endif
if graw = 10 then let gduty = 6 goto gpwm_adjust
endif
if graw = 11 then let gduty = 7 goto gpwm_adjust
endif
if graw = 12 then let gduty = 8 goto gpwm_adjust
endif
if graw = 13 then let gduty = 9 goto gpwm_adjust
endif
if graw = 14 then let gduty = 10 goto gpwm_adjust
endif
if graw = 15 then let gduty = 11 goto gpwm_adjust
endif
if graw = 16 then let gduty = 13 goto gpwm_adjust
endif
if graw = 17 then let gduty = 14 goto gpwm_adjust
endif
if graw = 18 then let gduty = 15 goto gpwm_adjust
endif
if graw = 19 then let gduty = 17 goto gpwm_adjust
endif
if graw = 20 then let gduty = 18 goto gpwm_adjust
endif
if graw = 21 then let gduty = 20 goto gpwm_adjust
endif
if graw = 22 then let gduty = 22 goto gpwm_adjust
endif
if graw = 23 then let gduty = 24 goto gpwm_adjust
g2:
endif
if graw = 24 then let gduty = 25 goto gpwm_adjust
endif
if graw = 25 then let gduty = 28 goto gpwm_adjust
endif
if graw = 26 then let gduty = 30 goto gpwm_adjust
endif
if graw = 27 then let gduty = 32 goto gpwm_adjust
endif
if graw = 28 then let gduty = 34 goto gpwm_adjust
endif
if graw = 29 then let gduty = 37 goto gpwm_adjust
endif
if graw = 30 then let gduty = 40 goto gpwm_adjust
endif
if graw = 31 then let gduty = 42 goto gpwm_adjust
endif
if graw = 32 then let gduty = 46 goto gpwm_adjust
endif
if graw = 33 then let gduty = 49 goto gpwm_adjust
endif
if graw = 34 then let gduty = 52 goto gpwm_adjust
endif
if graw = 35 then let gduty = 56 goto gpwm_adjust
endif
if graw = 36 then let gduty = 60 goto gpwm_adjust
g3:
endif
if graw = 37 then let gduty = 65 goto gpwm_adjust
endif
if graw = 38 then let gduty = 70 goto gpwm_adjust
endif
if graw = 39 then let gduty = 75 goto gpwm_adjust
endif
if graw = 40 then let gduty = 81 goto gpwm_adjust
endif
if graw = 41 then let gduty = 88 goto gpwm_adjust
endif
if graw = 42 then let gduty = 96 goto gpwm_adjust
endif
if graw = 43 then let gduty = 105 goto gpwm_adjust
endif
if graw = 44 then let gduty = 115 goto gpwm_adjust
endif
if graw = 45 then let gduty = 129 goto gpwm_adjust
endif
if graw = 46 then let gduty = 146 goto gpwm_adjust
endif
if graw = 47 then let gduty = 170 goto gpwm_adjust
endif
if graw = 48 then let gduty = 212 goto gpwm_adjust
endif
if graw = 49 then let gduty = 255 goto gpwm_adjust
endif
goto gpwm_adjust

blookup:
if braw >= 37 then gosub bl3
if braw >= 24 then gosub bl2
if braw >= 10 then gosub bl1
if braw = 0 then let bduty = 0 goto bpwm_adjust
endif
if braw = 1 then let bduty = 0 goto bpwm_adjust
endif
if braw = 2 then let bduty = 1 goto bpwm_adjust
endif
if braw = 3 then let bduty = 1 goto bpwm_adjust
endif
if braw = 4 then let bduty = 1 goto bpwm_adjust
endif
if braw = 5 then let bduty = 2 goto bpwm_adjust
endif
if braw = 6 then let bduty = 3 goto bpwm_adjust
endif
if braw = 7 then let bduty = 3 goto bpwm_adjust
endif
if braw = 8 then let bduty = 4 goto bpwm_adjust
endif
if braw = 9 then let bduty = 5 goto bpwm_adjust
bl1:
endif
if braw = 10 then let bduty = 6 goto bpwm_adjust
endif
if braw = 11 then let bduty = 7 goto bpwm_adjust
endif
if braw = 12 then let bduty = 8 goto bpwm_adjust
endif
if braw = 13 then let bduty = 9 goto bpwm_adjust
endif
if braw = 14 then let bduty = 10 goto bpwm_adjust
endif
if braw = 15 then let bduty = 11 goto bpwm_adjust
endif
if braw = 16 then let bduty = 13 goto bpwm_adjust
endif
if braw = 17 then let bduty = 14 goto bpwm_adjust
endif
if braw = 18 then let bduty = 15 goto bpwm_adjust
endif
if braw = 19 then let bduty = 17 goto bpwm_adjust
endif
if braw = 20 then let bduty = 18 goto bpwm_adjust
endif
if braw = 21 then let bduty = 20 goto bpwm_adjust
endif
if braw = 22 then let bduty = 22 goto bpwm_adjust
endif
if braw = 23 then let bduty = 24 goto bpwm_adjust
bl2:
endif
if braw = 24 then let bduty = 25 goto bpwm_adjust
endif
if braw = 25 then let bduty = 28 goto bpwm_adjust
endif
if braw = 26 then let bduty = 30 goto bpwm_adjust
endif
if braw = 27 then let bduty = 32 goto bpwm_adjust
endif
if braw = 28 then let bduty = 34 goto bpwm_adjust
endif
if braw = 29 then let bduty = 37 goto bpwm_adjust
endif
if braw = 30 then let bduty = 40 goto bpwm_adjust
endif
if braw = 31 then let bduty = 42 goto bpwm_adjust
endif
if braw = 32 then let bduty = 46 goto bpwm_adjust
endif
if braw = 33 then let bduty = 49 goto bpwm_adjust
endif
if braw = 34 then let bduty = 52 goto bpwm_adjust
endif
if braw = 35 then let bduty = 56 goto bpwm_adjust
endif
if braw = 36 then let bduty = 60 goto bpwm_adjust
bl3:
endif
if braw = 37 then let bduty = 65 goto bpwm_adjust
endif
if braw = 38 then let bduty = 70 goto bpwm_adjust
endif
if braw = 39 then let bduty = 75 goto bpwm_adjust
endif
if braw = 40 then let bduty = 81 goto bpwm_adjust
endif
if braw = 41 then let bduty = 88 goto bpwm_adjust
endif
if braw = 42 then let bduty = 96 goto bpwm_adjust
endif
if braw = 43 then let bduty = 105 goto bpwm_adjust
endif
if braw = 44 then let bduty = 115 goto bpwm_adjust
endif
if braw = 45 then let bduty = 129 goto bpwm_adjust
endif
if braw = 46 then let bduty = 146 goto bpwm_adjust
endif
if braw = 47 then let bduty = 170 goto bpwm_adjust
endif
if braw = 48 then let bduty = 212 goto bpwm_adjust
endif
if braw = 49 then let bduty = 255 goto bpwm_adjust
endif
goto bpwm_adjust