setfreq m32
symbol red = b.1
symbol green = b.2
symbol blue = b.3
symbol light = b.4
symbol rf_trans = c.0
symbol radc = b1
symbol gadc = b2
symbol badc = b3
symbol rawlight = b0
symbol crduty = b4
symbol cgduty = b5
symbol cbduty = b6
symbol lightstate = b7
symbol oradc = b8
symbol ogadc = b9
symbol obadc = b10
symbol olightstate = b11

send_rf:
readadc red, radc
readadc green, gadc
readadc blue, badc
readadc light, rawlight
gosub lightcalculate
if radc != oradc then gosub rcalculate
if gadc != ogadc then gosub gcalculate
if badc != obadc then gosub bcalculate
rfout rf_trans, (crduty,cgduty,cbduty,lightstate,b15,b12,b13,b14)
debug
goto send_rf:

lightcalculate:
if rawlight > 150 then let lightstate = 1
endif
if rawlight < 150 then let lightstate = 0
endif
return

rcalculate:
let crduty = radc*10/52
let oradc = radc
return

gcalculate:
let cgduty = gadc*10/52
let ogadc = gadc
return

bcalculate:
let cbduty = badc*10/52
let obadc = badc
return